<?php
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *                                   ATTENTION!
 * If you see this message in your browser (Internet Explorer, Mozilla Firefox, Google Chrome, etc.)
 * this means that PHP is not properly installed on your web server. Please refer to the PHP manual
 * for more details: http://php.net/manual/install.php 
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

    include_once dirname(__FILE__) . '/components/startup.php';
    include_once dirname(__FILE__) . '/components/application.php';
    include_once dirname(__FILE__) . '/' . 'authorization.php';


    include_once dirname(__FILE__) . '/' . 'database_engine/pgsql_engine.php';
    include_once dirname(__FILE__) . '/' . 'components/page/page_includes.php';

    function GetConnectionOptions()
    {
        $result = GetGlobalConnectionOptions();
        $result['client_encoding'] = 'utf8';
        GetApplication()->GetUserAuthentication()->applyIdentityToConnectionOptions($result);
        return $result;
    }

    
    
    
    // OnBeforePageExecute event handler
    
    
    
    class public_activity_edm_stockPage extends Page
    {
        protected function DoBeforeCreate()
        {
            $this->SetTitle('');
            $this->SetMenuLabel('Lagerbestände');
            $this->SetHeader(GetPagesHeader());
            $this->SetFooter(GetPagesFooter());
    
            $this->dataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."activity_edm_stock"');
            $this->dataset->addFields(
                array(
                    new StringField('report_gln', true, true),
                    new StringField('period', true, true),
                    new StringField('site_gln', true, true),
                    new StringField('tariff', true, true),
                    new StringField('waste_gtin', true, true),
                    new IntegerField('quantity'),
                    new StringField('msg_type')
                )
            );
            $this->dataset->AddLookupField('report_gln', 'public.contact_edm_gln', new StringField('gln'), new StringField('description', false, false, false, false, 'LA1', 'LT1'), 'LT1');
            $this->dataset->AddLookupField('site_gln', 'public.qcontactgln_select', new StringField('gln'), new StringField('selector', false, false, false, false, 'LA2', 'LT2'), 'LT2');
            $this->dataset->AddLookupField('tariff', 'public.qtariff_select', new StringField('id'), new StringField('selector', false, false, false, false, 'LA3', 'LT3'), 'LT3');
            $this->dataset->AddLookupField('waste_gtin', 'public.qwaste_catalog', new StringField('gtin'), new StringField('selector', false, false, false, false, 'LA4', 'LT4'), 'LT4');
        }
    
        protected function DoPrepare() {
    
        }
    
        protected function CreatePageNavigator()
        {
            $result = new CompositePageNavigator($this);
            
            $partitionNavigator = new PageNavigator('pnav', $this, $this->dataset);
            $partitionNavigator->SetRowsPerPage(10);
            $result->AddPageNavigator($partitionNavigator);
            
            return $result;
        }
    
        protected function CreateRssGenerator()
        {
            return null;
        }
    
        protected function setupCharts()
        {
    
        }
    
        protected function getFiltersColumns()
        {
            return array(
                new FilterColumn($this->dataset, 'report_gln', 'LA1', 'Report GLN'),
                new FilterColumn($this->dataset, 'period', 'period', 'Periode'),
                new FilterColumn($this->dataset, 'msg_type', 'msg_type', 'Buchungsart'),
                new FilterColumn($this->dataset, 'site_gln', 'LA2', 'Anlage'),
                new FilterColumn($this->dataset, 'tariff', 'LA3', 'Tarif'),
                new FilterColumn($this->dataset, 'waste_gtin', 'LA4', 'GTIN'),
                new FilterColumn($this->dataset, 'quantity', 'quantity', 'Menge')
            );
        }
    
        protected function setupQuickFilter(QuickFilter $quickFilter, FixedKeysArray $columns)
        {
            $quickFilter
                ->addColumn($columns['report_gln'])
                ->addColumn($columns['period'])
                ->addColumn($columns['msg_type'])
                ->addColumn($columns['site_gln'])
                ->addColumn($columns['tariff'])
                ->addColumn($columns['waste_gtin'])
                ->addColumn($columns['quantity']);
        }
    
        protected function setupColumnFilter(ColumnFilter $columnFilter)
        {
            $columnFilter
                ->setOptionsFor('report_gln')
                ->setOptionsFor('period')
                ->setOptionsFor('msg_type')
                ->setOptionsFor('site_gln')
                ->setOptionsFor('tariff')
                ->setOptionsFor('waste_gtin');
        }
    
        protected function setupFilterBuilder(FilterBuilder $filterBuilder, FixedKeysArray $columns)
        {
            $main_editor = new DynamicCombobox('report_gln_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_activity_edm_stock_report_gln_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('report_gln', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_activity_edm_stock_report_gln_search');
            
            $text_editor = new TextEdit('report_gln');
            
            $filterBuilder->addColumn(
                $columns['report_gln'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('period_edit');
            
            $filterBuilder->addColumn(
                $columns['period'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new ComboBox('msg_type_edit', $this->GetLocalizerCaptions()->GetMessageString('PleaseSelect'));
            $main_editor->addChoice('Lagerstand', 'Lagerstand');
            $main_editor->addChoice('Deponievolumen', 'Deponievolumen');
            $main_editor->addChoice('Lagerstandkorrektur', 'Lagerstandkorrektur');
            $main_editor->SetAllowNullValue(false);
            
            $multi_value_select_editor = new MultiValueSelect('msg_type');
            $multi_value_select_editor->setChoices($main_editor->getChoices());
            
            $text_editor = new TextEdit('msg_type');
            
            $filterBuilder->addColumn(
                $columns['msg_type'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('site_gln_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_activity_edm_stock_site_gln_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('site_gln', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_activity_edm_stock_site_gln_search');
            
            $text_editor = new TextEdit('site_gln');
            
            $filterBuilder->addColumn(
                $columns['site_gln'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('tariff_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_activity_edm_stock_tariff_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('tariff', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_activity_edm_stock_tariff_search');
            
            $text_editor = new TextEdit('tariff');
            
            $filterBuilder->addColumn(
                $columns['tariff'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('waste_gtin_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_activity_edm_stock_waste_gtin_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('waste_gtin', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_activity_edm_stock_waste_gtin_search');
            
            $text_editor = new TextEdit('waste_gtin');
            
            $filterBuilder->addColumn(
                $columns['waste_gtin'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('quantity_edit');
            
            $filterBuilder->addColumn(
                $columns['quantity'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
        }
    
        protected function AddOperationsColumns(Grid $grid)
        {
            $actions = $grid->getActions();
            $actions->setCaption($this->GetLocalizerCaptions()->GetMessageString('Actions'));
            $actions->setPosition(ActionList::POSITION_LEFT);
            
            if ($this->GetSecurityInfo()->HasViewGrant())
            {
                $operation = new AjaxOperation(OPERATION_VIEW,
                    $this->GetLocalizerCaptions()->GetMessageString('View'),
                    $this->GetLocalizerCaptions()->GetMessageString('View'), $this->dataset,
                    $this->GetModalGridViewHandler(), $grid);
                $operation->setUseImage(true);
                $actions->addOperation($operation);
            }
            
            if ($this->GetSecurityInfo()->HasEditGrant())
            {
                $operation = new AjaxOperation(OPERATION_EDIT,
                    $this->GetLocalizerCaptions()->GetMessageString('Edit'),
                    $this->GetLocalizerCaptions()->GetMessageString('Edit'), $this->dataset,
                    $this->GetGridEditHandler(), $grid);
                $operation->setUseImage(true);
                $actions->addOperation($operation);
                $operation->OnShow->AddListener('ShowEditButtonHandler', $this);
            }
            
            if ($this->GetSecurityInfo()->HasDeleteGrant())
            {
                $operation = new LinkOperation($this->GetLocalizerCaptions()->GetMessageString('Delete'), OPERATION_DELETE, $this->dataset, $grid);
                $operation->setUseImage(true);
                $actions->addOperation($operation);
                $operation->OnShow->AddListener('ShowDeleteButtonHandler', $this);
                $operation->SetAdditionalAttribute('data-modal-operation', 'delete');
                $operation->SetAdditionalAttribute('data-delete-handler-name', $this->GetModalGridDeleteHandler());
            }
        }
    
        protected function AddFieldColumns(Grid $grid, $withDetails = true)
        {
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA1', 'Report GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_LA1_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_period_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for msg_type field
            //
            $column = new TextViewColumn('msg_type', 'msg_type', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_msg_type_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('site_gln', 'LA2', 'Anlage', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_LA2_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('tariff', 'LA3', 'Tarif', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_LA3_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA4', 'GTIN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_LA4_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for quantity field
            //
            $column = new NumberViewColumn('quantity', 'quantity', 'Menge', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(4);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
        }
    
        protected function AddSingleRecordViewColumns(Grid $grid)
        {
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA1', 'Report GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_LA1_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_period_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for msg_type field
            //
            $column = new TextViewColumn('msg_type', 'msg_type', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_msg_type_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('site_gln', 'LA2', 'Anlage', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_LA2_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('tariff', 'LA3', 'Tarif', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_LA3_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA4', 'GTIN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_LA4_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for quantity field
            //
            $column = new NumberViewColumn('quantity', 'quantity', 'Menge', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(4);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $grid->AddSingleRecordViewColumn($column);
        }
    
        protected function AddEditColumns(Grid $grid)
        {
            //
            // Edit column for report_gln field
            //
            $editor = new DynamicCombobox('report_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Report GLN', 'report_gln', 'LA1', 'edit_public_activity_edm_stock_report_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for period field
            //
            $editor = new TextEdit('period_edit');
            $editColumn = new CustomEditColumn('Periode', 'period', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for msg_type field
            //
            $editor = new ComboBox('msg_type_edit', $this->GetLocalizerCaptions()->GetMessageString('PleaseSelect'));
            $editor->addChoice('Lagerstand', 'Lagerstand');
            $editor->addChoice('Deponievolumen', 'Deponievolumen');
            $editor->addChoice('Lagerstandkorrektur', 'Lagerstandkorrektur');
            $editColumn = new CustomEditColumn('Buchungsart', 'msg_type', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for site_gln field
            //
            $editor = new DynamicCombobox('site_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qcontactgln_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Anlage', 'site_gln', 'LA2', 'edit_public_activity_edm_stock_site_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'selector', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for tariff field
            //
            $editor = new DynamicCombobox('tariff_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qtariff_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('id'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Tarif', 'tariff', 'LA3', 'edit_public_activity_edm_stock_tariff_search', $editor, $this->dataset, $lookupDataset, 'id', 'selector', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for waste_gtin field
            //
            $editor = new DynamicCombobox('waste_gtin_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $editColumn = new DynamicLookupEditColumn('GTIN', 'waste_gtin', 'LA4', 'edit_public_activity_edm_stock_waste_gtin_search', $editor, $this->dataset, $lookupDataset, 'gtin', 'selector', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for quantity field
            //
            $editor = new TextEdit('quantity_edit');
            $editColumn = new CustomEditColumn('Menge', 'quantity', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
        }
    
        protected function AddMultiEditColumns(Grid $grid)
        {
            //
            // Edit column for msg_type field
            //
            $editor = new ComboBox('msg_type_edit', $this->GetLocalizerCaptions()->GetMessageString('PleaseSelect'));
            $editor->addChoice('Lagerstand', 'Lagerstand');
            $editor->addChoice('Deponievolumen', 'Deponievolumen');
            $editor->addChoice('Lagerstandkorrektur', 'Lagerstandkorrektur');
            $editColumn = new CustomEditColumn('Buchungsart', 'msg_type', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for quantity field
            //
            $editor = new TextEdit('quantity_edit');
            $editColumn = new CustomEditColumn('Menge', 'quantity', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
        }
    
        protected function AddInsertColumns(Grid $grid)
        {
            //
            // Edit column for report_gln field
            //
            $editor = new DynamicCombobox('report_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Report GLN', 'report_gln', 'LA1', 'insert_public_activity_edm_stock_report_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for period field
            //
            $editor = new TextEdit('period_edit');
            $editColumn = new CustomEditColumn('Periode', 'period', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for msg_type field
            //
            $editor = new ComboBox('msg_type_edit', $this->GetLocalizerCaptions()->GetMessageString('PleaseSelect'));
            $editor->addChoice('Lagerstand', 'Lagerstand');
            $editor->addChoice('Deponievolumen', 'Deponievolumen');
            $editor->addChoice('Lagerstandkorrektur', 'Lagerstandkorrektur');
            $editColumn = new CustomEditColumn('Buchungsart', 'msg_type', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for site_gln field
            //
            $editor = new DynamicCombobox('site_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qcontactgln_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Anlage', 'site_gln', 'LA2', 'insert_public_activity_edm_stock_site_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'selector', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for tariff field
            //
            $editor = new DynamicCombobox('tariff_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qtariff_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('id'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Tarif', 'tariff', 'LA3', 'insert_public_activity_edm_stock_tariff_search', $editor, $this->dataset, $lookupDataset, 'id', 'selector', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for waste_gtin field
            //
            $editor = new DynamicCombobox('waste_gtin_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $editColumn = new DynamicLookupEditColumn('GTIN', 'waste_gtin', 'LA4', 'insert_public_activity_edm_stock_waste_gtin_search', $editor, $this->dataset, $lookupDataset, 'gtin', 'selector', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for quantity field
            //
            $editor = new TextEdit('quantity_edit');
            $editColumn = new CustomEditColumn('Menge', 'quantity', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            $grid->SetShowAddButton(true && $this->GetSecurityInfo()->HasAddGrant());
        }
    
        private function AddMultiUploadColumn(Grid $grid)
        {
    
        }
    
        protected function AddPrintColumns(Grid $grid)
        {
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA1', 'Report Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_LA1_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Period', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_period_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for msg_type field
            //
            $column = new TextViewColumn('msg_type', 'msg_type', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_msg_type_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('site_gln', 'LA2', 'Site Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_LA2_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('tariff', 'LA3', 'Tariff', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_LA3_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA4', 'Waste Gtin', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_LA4_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for quantity field
            //
            $column = new NumberViewColumn('quantity', 'quantity', 'Menge', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(4);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $grid->AddPrintColumn($column);
        }
    
        protected function AddExportColumns(Grid $grid)
        {
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA1', 'Report Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_LA1_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Period', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_period_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for msg_type field
            //
            $column = new TextViewColumn('msg_type', 'msg_type', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_msg_type_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('site_gln', 'LA2', 'Site Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_LA2_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('tariff', 'LA3', 'Tariff', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_LA3_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA4', 'Waste Gtin', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_LA4_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for quantity field
            //
            $column = new NumberViewColumn('quantity', 'quantity', 'Menge', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(4);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $grid->AddExportColumn($column);
        }
    
        private function AddCompareColumns(Grid $grid)
        {
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA1', 'Report GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_LA1_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_period_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for msg_type field
            //
            $column = new TextViewColumn('msg_type', 'msg_type', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_msg_type_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('site_gln', 'LA2', 'Anlage', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_LA2_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('tariff', 'LA3', 'Tarif', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_LA3_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA4', 'GTIN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_activity_edm_stockGrid_LA4_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for quantity field
            //
            $column = new NumberViewColumn('quantity', 'quantity', 'Menge', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(4);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $grid->AddCompareColumn($column);
        }
    
        private function AddCompareHeaderColumns(Grid $grid)
        {
    
        }
    
        public function GetPageDirection()
        {
            return null;
        }
    
        public function isFilterConditionRequired()
        {
            return true;
        }
    
        protected function ApplyCommonColumnEditProperties(CustomEditColumn $column)
        {
            $column->SetDisplaySetToNullCheckBox(false);
            $column->SetDisplaySetToDefaultCheckBox(false);
    		$column->SetVariableContainer($this->GetColumnVariableContainer());
        }
    
        function GetCustomClientScript()
        {
            return ;
        }
        
        function GetOnPageLoadedClientScript()
        {
            return ;
        }
        
        public function GetEnableModalGridInsert() { return true; }
        public function GetEnableModalSingleRecordView() { return true; }
        
        public function GetEnableModalGridEdit() { return true; }
        
        protected function GetEnableModalGridDelete() { return true; }
    
        protected function CreateGrid()
        {
            $result = new Grid($this, $this->dataset);
            if ($this->GetSecurityInfo()->HasDeleteGrant())
               $result->SetAllowDeleteSelected(false);
            else
               $result->SetAllowDeleteSelected(false);   
            
            ApplyCommonPageSettings($this, $result);
            
            $result->SetUseImagesForActions(true);
            $defaultSortedColumns = array();
            $defaultSortedColumns[] = new SortColumn('period', 'DESC');
            $result->setDefaultOrdering($defaultSortedColumns);
            $result->SetUseFixedHeader(false);
            $result->SetShowLineNumbers(false);
            $result->SetViewMode(ViewMode::TABLE);
            $result->setEnableRuntimeCustomization(true);
            $result->setAllowCompare(true);
            $this->AddCompareHeaderColumns($result);
            $this->AddCompareColumns($result);
            $result->setMultiEditAllowed($this->GetSecurityInfo()->HasEditGrant() && false);
            $result->setTableBordered(false);
            $result->setTableCondensed(false);
            
            $result->SetHighlightRowAtHover(false);
            $result->SetWidth('');
            $this->AddOperationsColumns($result);
            $this->AddFieldColumns($result);
            $this->AddSingleRecordViewColumns($result);
            $this->AddEditColumns($result);
            $this->AddMultiEditColumns($result);
            $this->AddInsertColumns($result);
            $this->AddPrintColumns($result);
            $this->AddExportColumns($result);
            $this->AddMultiUploadColumn($result);
    
    
            $this->SetShowPageList(true);
            $this->SetShowTopPageNavigator(true);
            $this->SetShowBottomPageNavigator(false);
            $this->setPrintListAvailable(true);
            $this->setPrintListRecordAvailable(false);
            $this->setPrintOneRecordAvailable(true);
            $this->setAllowPrintSelectedRecords(true);
            $this->setExportListAvailable(array('pdf', 'excel', 'word', 'xml', 'csv'));
            $this->setExportSelectedRecordsAvailable(array('pdf', 'excel', 'word', 'xml', 'csv'));
            $this->setExportListRecordAvailable(array());
            $this->setExportOneRecordAvailable(array('pdf', 'excel', 'word', 'xml', 'csv'));
    
            return $result;
        }
     
        protected function setClientSideEvents(Grid $grid) {
    
        }
    
        protected function doRegisterHandlers() {
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA1', 'Report GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_LA1_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_period_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for msg_type field
            //
            $column = new TextViewColumn('msg_type', 'msg_type', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_msg_type_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('site_gln', 'LA2', 'Anlage', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_LA2_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('tariff', 'LA3', 'Tarif', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_LA3_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA4', 'GTIN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_LA4_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA1', 'Report Gln', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_LA1_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Period', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_period_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for msg_type field
            //
            $column = new TextViewColumn('msg_type', 'msg_type', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_msg_type_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('site_gln', 'LA2', 'Site Gln', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_LA2_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('tariff', 'LA3', 'Tariff', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_LA3_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA4', 'Waste Gtin', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_LA4_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA1', 'Report GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_LA1_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_period_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for msg_type field
            //
            $column = new TextViewColumn('msg_type', 'msg_type', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_msg_type_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('site_gln', 'LA2', 'Anlage', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_LA2_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('tariff', 'LA3', 'Tarif', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_LA3_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA4', 'GTIN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_LA4_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_public_activity_edm_stock_report_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qcontactgln_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_public_activity_edm_stock_site_gln_search', 'gln', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qtariff_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('id'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_public_activity_edm_stock_tariff_search', 'id', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_public_activity_edm_stock_waste_gtin_search', 'gtin', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_activity_edm_stock_report_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qcontactgln_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_activity_edm_stock_site_gln_search', 'gln', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qtariff_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('id'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_activity_edm_stock_tariff_search', 'id', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_activity_edm_stock_waste_gtin_search', 'gtin', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('report_gln', 'LA1', 'Report GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_LA1_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_period_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for msg_type field
            //
            $column = new TextViewColumn('msg_type', 'msg_type', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_msg_type_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('site_gln', 'LA2', 'Anlage', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_LA2_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('tariff', 'LA3', 'Tarif', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_LA3_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA4', 'GTIN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_stockGrid_LA4_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_public_activity_edm_stock_report_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qcontactgln_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_public_activity_edm_stock_site_gln_search', 'gln', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qtariff_select"');
            $lookupDataset->addFields(
                array(
                    new StringField('id'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_public_activity_edm_stock_tariff_search', 'id', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_public_activity_edm_stock_waste_gtin_search', 'gtin', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
        }
       
        protected function doCustomRenderColumn($fieldName, $fieldData, $rowData, &$customText, &$handled)
        { 
    
        }
    
        protected function doCustomRenderPrintColumn($fieldName, $fieldData, $rowData, &$customText, &$handled)
        { 
    
        }
    
        protected function doCustomRenderExportColumn($exportType, $fieldName, $fieldData, $rowData, &$customText, &$handled)
        { 
    
        }
    
        protected function doCustomDrawRow($rowData, &$cellFontColor, &$cellFontSize, &$cellBgColor, &$cellItalicAttr, &$cellBoldAttr)
        {
    
        }
    
        protected function doExtendedCustomDrawRow($rowData, &$rowCellStyles, &$rowStyles, &$rowClasses, &$cellClasses)
        {
    
        }
    
        protected function doCustomRenderTotal($totalValue, $aggregate, $columnName, &$customText, &$handled)
        {
    
        }
    
        protected function doCustomDefaultValues(&$values, &$handled) 
        {
    
        }
    
        protected function doCustomCompareColumn($columnName, $valueA, $valueB, &$result)
        {
    
        }
    
        protected function doBeforeInsertRecord($page, &$rowData, $tableName, &$cancel, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doBeforeUpdateRecord($page, $oldRowData, &$rowData, $tableName, &$cancel, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doBeforeDeleteRecord($page, &$rowData, $tableName, &$cancel, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doAfterInsertRecord($page, $rowData, $tableName, &$success, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doAfterUpdateRecord($page, $oldRowData, $rowData, $tableName, &$success, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doAfterDeleteRecord($page, $rowData, $tableName, &$success, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doCustomHTMLHeader($page, &$customHtmlHeaderText)
        { 
    
        }
    
        protected function doGetCustomTemplate($type, $part, $mode, &$result, &$params)
        {
    
        }
    
        protected function doGetCustomExportOptions(Page $page, $exportType, $rowData, &$options)
        {
    
        }
    
        protected function doFileUpload($fieldName, $rowData, &$result, &$accept, $originalFileName, $originalFileExtension, $fileSize, $tempFileName)
        {
    
        }
    
        protected function doPrepareChart(Chart $chart)
        {
    
        }
    
        protected function doPrepareColumnFilter(ColumnFilter $columnFilter)
        {
    
        }
    
        protected function doPrepareFilterBuilder(FilterBuilder $filterBuilder, FixedKeysArray $columns)
        {
    
        }
    
        protected function doGetSelectionFilters(FixedKeysArray $columns, &$result)
        {
    
        }
    
        protected function doGetCustomFormLayout($mode, FixedKeysArray $columns, FormLayout $layout)
        {
    
        }
    
        protected function doGetCustomColumnGroup(FixedKeysArray $columns, ViewColumnGroup $columnGroup)
        {
    
        }
    
        protected function doPageLoaded()
        {
    
        }
    
        protected function doCalculateFields($rowData, $fieldName, &$value)
        {
    
        }
    
        protected function doGetCustomPagePermissions(Page $page, PermissionSet &$permissions, &$handled)
        {
    
        }
    
        protected function doGetCustomRecordPermissions(Page $page, &$usingCondition, $rowData, &$allowEdit, &$allowDelete, &$mergeWithDefault, &$handled)
        {
    
        }
    
    }

    SetUpUserAuthorization();

    try
    {
        $Page = new public_activity_edm_stockPage("public_activity_edm_stock", "frmActivity_edm_stock.php", GetCurrentUserPermissionSetForDataSource("public.activity_edm_stock"), 'UTF-8');
        $Page->SetRecordPermission(GetCurrentUserRecordPermissionsForDataSource("public.activity_edm_stock"));
        GetApplication()->SetMainPage($Page);
        GetApplication()->Run();
    }
    catch(Exception $e)
    {
        ShowErrorPage($e);
    }
	
