<?php
error_reporting(0);

define(TYPE_NONE,0);
define(TYPE_OBJ,1);
define(TYPE_PROP,2);
define(DPI,96);
define(MARGIN_TOP,50);
define(MARGIN_LEFT,50);
define(PAGE_SPACING,20);

$PAGESIZES['Letter']['W']='816';
$PAGESIZES['Letter']['H']='1056';

function IncToPix($v){
  return ceil(($v*DPI)/100);
}

function getPageWidth($l){
  global $PAGESIZES;
  
  return $PAGESIZES[$l]['W'];
}

function getPageHeight($l){
  global $PAGESIZES;
  
  return $PAGESIZES[$l]['H'];
}

class xmlElement {
protected $properties;
protected $attributes;
protected $objects;
var $start;
var $name;
protected $started;
protected $curTag;

  function debug($str) {
//    if ($this->debuglevel)
//      echo '<pre>'.get_class($this).': '.$this->curTag.': '.$str."\n</pre>";
  } 
  
  function setAttributes($attrs){
    if (count($attrs)==0) return;
    
    foreach ($attrs as $k => $v) {
      if (isset($this->attributes[$name.'^'.$k])){
        $el = $this->attributes[$name.'^'.$k];
        $this->$el = $v;
      }
    }
  }
  
  function elementSelect($unselect = false) {
    if (isset($this->properties[$this->curTag])) {
      // we need to handle the property
      $this->currentType=TYPE_PROP;
      $this->currentValue=$this->properties[$this->curTag];
    } else if (isset($this->objects[$this->curTag])){
      $this->currentType=TYPE_OBJ;
      $this->currentValue=$this->objects[$this->curTag];
    } else if ($unselect) {
      $this->currentType = TYPE_NONE;
      $this->currentValue = '';
    }
  }
  
  public function elementStart($parser,$name, $attrs) {
    // start of element $name
    if ($this->started) {
      $this->curTag .= "^$name";
      $this->elementSelect(false);
      $this->debug('check '.$this->curValue);
      if ($this->currentType==TYPE_OBJ) {
        $obj = $this->currentValue;
        $this->$obj->elementStart($parser,$name,$attrs);
        $this->debug('start object: '.$this->currentValue);
      } else if ($this->currentType==TYPE_PROP){
        $this->debug('start property: '.$this->currentValue);
        if (!(strpos($this->currentValue,'=')===FALSE)) {
          $x = explode('=',$this->currentValue);
          $this->$x[0]=$x[1];
        }
      }
    } else {
      if ($name==$this->start){
        $this->started = true;
        $this->setAttributes($attrs);
        $this->curTag = '';
        $this->elementSelect(false);
      } else {
        $this->debug('not started. '.$name.' '.$this->start);
      }
    }
  }
  
  public function elementEnd($parser,$name) {
    if (!$this->started) return;
    
    if ($this->currentType==TYPE_OBJ) {
      // we need to call the object end
      $obj = $this->currentValue;
      $this->$obj->elementEnd($parser,$name);
    }
    $caret_pos = strrpos($this->curTag,'^');
    $this->curTag = substr($this->curTag,0,$caret_pos);
    if ($this->currentType==TYPE_PROP) {
      $this->elementSelect(true);
    } else if ($this->currentType==TYPE_OBJ) {
      // need to find a way to deselect object so not to pass strange values
      $obj = $this->currentValue;
      if ($this->$obj->start==$name){
        $this->elementSelect(true);
      } else {
        $this->elementSelect(false);
      }
    } else {
      $this->elementSelect(true);
    }
    if ($this->curTag=='' and $this->start == $name){
      $this->started = false;
    }
  }
  
  public function elementData($parser,$data){
    $this->debug($data);
    if (!$this->started) return;
    if ($this->currentType==TYPE_OBJ){
      $obj = $this->currentValue;
      $this->$obj->elementData($parser,$data);
    } else if ($this->currentType==TYPE_PROP){
      if (strpos($this->currentValue,'=')===FALSE) {
        $prop = $this->currentValue;
        $this->$prop = $data;
      }
    }
  }
  
  function xmlElement($start=''){
    if ($start!='') {
      $this->start = $start;
    }
    $this->properties = array();
    $this->attributes = array();
    $this->objects = array();
    $this->currentType = TYPE_NONE;
    $this->start=='';
    $this->started = false;
  }
}

class xmlElementList {
var $subclass;
var $elements;
var $start;

  function xmlElementList($className,$start){
    $this->elements = array();
    $this->subclass = $className;
    $this->start = $start;
  }
  
  public function count(){
    return count($this->elements);
  }

  public function addElement() {
    $obj = $this->subclass;
    $this->elements[] = new $obj($this->start);
    // this is done by the internal elementStart...
//    $this->elemens[$this->count()-1]->setAttributes($attrs);
  }  
  
  function elementStart($parser,$name,$attrs) {
    if ($name == $this->start){
      $this->addElement();
    }
    $count = $this->count();
    if ($count>0) {
      $this->elements[$count-1]->elementStart($parser,$name,$attrs);
    }
  }
  
  function elementEnd($parser,$name) {
    $count = $this->count();
    if ($count>0) {
      $this->elements[$count-1]->elementEnd($parser,$name);
    }
  }
  
  function elementData($parser,$data) {
    $count = $this->count();
    if ($count>0) {
      $this->elements[$count-1]->elementData($parser,$data);
    }
  }
}

class xmlParameterItem extends xmlElement {
var $value;
var $description;

  function xmlParameterItem($start='') {
    $this->start = 'ITEM';
    if ($start != '') {
      $this->start = $start;
    }
    $this->attributes['^VALUE']='value';
    $this->properties['']='description';
  }
}
class xmlParameter extends xmlElement {
  var $name;
  var $description;
  var $type;
  var $default;
  var $active;
  var $listtype;
  var $query;
  var $items;

  function xmlParameter ($start='') {
    $this->start = 'PARAMETER';
    if ($start!='') {
      $this->start = $start;
    }
    $this->attributes['^NAME']='name';
    $this->attributes['^TYPE']='type';
    $this->attributes['^DEFAULT']='default';
    $this->attributes['^ACTIVE']='active';
    $this->attributes['^LISTTYPE']='listtype';
    $this->properties['^DESCRIPTION']='description';
    $this->properties['^QUERY']='query';
    $this->objects['^ITEM']='items';
    
    $this->items = new xmlElementList('xmlParameterItem','ITEM');
  }
}

class xmlQuerySource extends xmlElement {
  var $name;
  var $sql;
  var $result;
  var $pos;
  var $isOpen;
  var $peof;
  
  function xmlQuerySource($start = '') {
    $this->start = 'QUERYSOURCE';
    if ($start!='') {
      $this->start = $start;
    }
    $this->properties['^NAME']='name';
    $this->properties['^SQL']='sql';
    $this->isOpen = false;
    $this->peof = true;
  }
  
  function getSQL($params) {
    $sql = $this->sql;
    foreach ($params as $p){
      $sql = str_replace('?? value("'.$p->name.'") ??',"'".$p->value."'",$sql);
    }
    return $sql;
  }
  
  function open($report){
    if ($this->isOpen) return;
    /* run the queries */
    $QUERY = array();
    $sql = $this->getSQL($report->parameters->elements);
    $res = @pg_query($sql);
    $this->result = array();
    while ($row = @pg_fetch_assoc($res)){
     $this->result[]=$row;
    }
    $this->first();
    @pg_freeresult($res);
    $this->isOpen = true;
  }
  
  function first() {
    $this->pos = 0;
    $this->peof = false;
  }
  
  function next() {
    $this->pos++;
  }
  
  function last() {
    $this->pos = count($this->result)-1;
  }
  
  function previous() {
    if ($this->pos>0)
      $this->pos--;
  }
  
  function eof() {
    if (count($this->result)<=$this->pos){
      return true;
    } else {
      return false;
    }
  }
  
  function getField($f){
    if (!$this->isOpen) { return ''; }
    if ($this->pos == count($this->result)){
      return '';
    } else {
      return $this->result[$this->pos][$f];
    }
  }
}

class xmlDisplayElement extends xmlElement {
  var $name;
  var $x,$y,$width,$height;

  function xmlDisplayElement($start='') {
    parent::xmlElement($start);
    $this->propertied['^NAME']='name';
    $this->properties['^RECT^X']='x';
    $this->properties['^RECT^Y']='y';
    $this->properties['^RECT^WIDTH']='width';
    $this->properties['^RECT^HEIGHT']='height';
    $this->x = 0;
    $this->y = 0;
  }
  
  function getPosition($x=0,$y=0){
    return 'position: absolute; top: '.(IncToPix($this->y)+$y).'px; left:'.(IncToPix($this->x)+$x).'px; width: '.IncToPix($this->width).'px; height: '.IncToPix($this->height).'px;';
  }
  
  
}

class xmlSection extends xmlDisplayElement {
  var $name;
  var $height;
  var $querySource;
  var $fields;
  var $labels;
  var $texts;
  var $lines;
  var $groups;
  
  function xmlSection($start = ''){
    parent::xmlDisplayElement($start);
    if ($start!=''){
      $this->start = $start;
    } else {
      $this->start = 'SECTION';
    }
    $this->properties['^NAME']='name';
    $this->properties['^DETAIL^HEIGHT']='height';
    $this->properties['^DETAIL^KEY^QUERY']='querySource';
    $this->properties['^COLUMN']='column';
    
    $this->objects['^DETAIL^FIELD']='fields';
    $this->objects['^DETAIL^LABEL']='labels';
    $this->objects['^DETAIL^TEXT']='texts';
    $this->objects['^DETAIL^LINE']='lines';
    $this->objects['^DETAIL^IMAGE']='images';
    $this->objects['^GROUP']='groups';
    
    $this->fields = new xmlElementList('xmlField','FIELD');
    $this->labels = new xmlElementList('xmlLabel','LABEL');
    $this->texts = new xmlElementList('xmlText','TEXT');
    $this->lines = new xmlElementList('xmlLine','LINE');
    $this->images = new xmlElementList('xmlImage','IMAGE');
    $this->groups = new xmlElementList('xmlGroup','GROUP');
  }

    function render($report,$x,$y){
      $qs = $report->getSource($this->querySource);
      $ly = 0;
      $columnvalue = 'as dfhjkla sdhfkl a7823 haskd fhasjkdf';
      $qs->first();
      while (!$qs->eof()) {
        echo '<div id="section" style="border: 0px solid #ff0000;'.$this->getPosition($x,$y).'">'."\n";
        foreach ($this->groups->elements as $o){
          if ($qs->getField($this->column)!=$columnvalue){
            $ly = $o->head->render($report,0,$ly);
            $columnvalue = $qs->getField($this->column);
          }
        }
        foreach ($this->fields->elements as $o){
          $o->render($report,0,$ly);
        }
        foreach ($this->labels->elements as $o){
          $o->render($report,0,$ly);
        }
        foreach ($this->texts->elements as $o){
          $o->render($report,0,$ly);
        }
        foreach ($this->lines->elements as $o){
          $o->render($report,0,$ly);
        }
        $ly += IncToPix($this->height);
        $qs->next();
        foreach ($this->groups->elements as $o){
          if ($qs->getField($this->column)!=$value or ($qs->eof())){
            $ly = $o->foot->render($report,0,$ly);
            $o->columnvalue = $qs->getField($this->column);
          }
        }
        echo '</div>'."\n";
        $y = $y+$ly;
        $ly = 0;
      }
    return $y;
  }

}

class xmlGroupHead extends xmlSection {
var $fields,$labels,$texts,$lines;

  function xmlGroupHead($start='HEAD') {
    parent::xmlSection($start);
    $this->properties['^HEIGHT']='height';
    
    $this->objects['^FIELD']='fields';
    $this->objects['^LABEL']='labels';
    $this->objects['^TEXT']='texts';
    $this->objects['^LINE']='lines';
    $this->objects['^IMAGE']='images';
    $this->columnvalue = 'asdfh 12389 asdfj 1238y ashfjk ashdfk asdhyfu 2eashdjfk hasjkd fyuasf hasdjkf';
  }
  
  function render($report,$x,$y){
    echo '<div id="head" style="border: 0px solid #ff0000;'.$this->getPosition($x,$y).'">'."\n";
    foreach ($this->fields->elements as $o){
      $o->render($report,0,0);
    }
    foreach ($this->labels->elements as $o){
       $o->render($report,0,0);
    }
    foreach ($this->texts->elements as $o){
       $o->render($report,0,0);
    }
    foreach ($this->lines->elements as $o){
       $o->render($report,0,0);
    }
    foreach ($this->images->elements as $o){
       $o->render($report,0,0);
    }
    echo '</div>'."\n";
    $y = $y+IncToPix($this->height);
    return $y;
  }
}

class xmlGroupFoot extends xmlSection {
var $fields,$labels,$texts,$lines;

  function xmlGroupFoot($start='FOOT') {
    parent::xmlSection($start);
    
    $this->objects['^FIELD']='fields';
    $this->objects['^LABEL']='labels';
    $this->objects['^TEXT']='texts';
    $this->objects['^LINE']='lines';
    $this->objects['^IMAGE']='images';
    $this->columnvalue = 'asdfh 12389 asdfj 1238y ashfjk ashdfk asdhyfu 2eashdjfk hasjkd fyuasf hasdjkf';
  }

  function render($report,$x,$y){
    echo '<div id="foot" style="border: 0px solid #ff0000;'.$this->getPosition($x,$y).'">'."\n";
    foreach ($this->fields->elements as $o){
      $o->render($report,0,0);
    }
    foreach ($this->labels->elements as $o){
       $o->render($report,0,0);
    }
    foreach ($this->texts->elements as $o){
       $o->render($report,0,0);
    }
    foreach ($this->lines->elements as $o){
       $o->render($report,0,0);
    }
    echo '</div>'."\n";
    $y = $y+IncToPix($this->height);
    return $y;
  }
  
}

class xmlGroup extends xmlElement {
var $name;
var $column;
var $head;
var $foot;

  function xmlGroup($start) {
    parent::xmlElement($start);
    $this->properties['^NAME']='name';
    $this->properties['^COLUMN']='column';
    
    $this->objects['^HEAD']='head';
    $this->objects['^FOOT']='foot';

    $this->head = new xmlGroupHead('HEAD');
    $this->foot = new xmlGroupFoot('FOOT');    
  }
  
}

class xmlField extends xmlDisplayElement {
  var $fontface, $fontsize, $fontweight;
  var $valign,$halign;
  var $dataquery,$datacolumn;
  
  function xmlField($start){
    parent::xmlDisplayElement($start);
    $this->properties['^FONT^FACE']='fontface';
    $this->properties['^FONT^SIZE']='fontsize';
    $this->properties['^FONT^WEIGHT']='fontweight';
    $this->properties['^DATA^QUERY']='dataquery';
    $this->properties['^DATA^COLUMN']='datacolumn';
    $this->properties['^RIGHT']='halign=right';
    $this->properties['^HCENTER']='halign=center';
    $this->properties['^LEFT']='halign=left';
    $this->properties['^TOP']='valign=top';
    $this->properties['^VCENTER']='valign=middle';
  }
  
  function render($report,$x,$y){
    echo '<div id="field" style="text-align: '.$this->halign.'; vertical-align: '.$this->valign.'; font-family: '.$this->fontface.'; font-size: '.$this->fontsize.'pt; font-weight: '.$this->fontweight.'; '.$this->getPosition($x,$y).' ">'.$report->getSource($this->dataquery)->getField($this->datacolumn).'</div>'."\n";
    return $y;
  }
}

class xmlLabel extends xmlDisplayElement {
  var $fontface, $fontsize, $fontweight;
  var $valign,$halign;
  var $string;
  
  function xmlLabel($start){
    parent::xmlDisplayElement($start);
    $this->properties['^FONT^FACE']='fontface';
    $this->properties['^FONT^SIZE']='fontsize';
    $this->properties['^FONT^WEIGHT']='fontweight';
    $this->properties['^RIGHT']='halign=right';
    $this->properties['^HCENTER']='halign=center';
    $this->properties['^LEFT']='halign=left';
    $this->properties['^TOP']='valign=top';
    $this->properties['^VCENTER']='valign=middle';
    $this->properties['^BOTTOM']='valign=bottom';
    $this->properties['^STRING']='string';
  }

  function render($report,$x,$y){
    echo '<div id="label" style="text-align: '.$this->halign.'; vertical-align: '.$this->valign.'; font-family: '.$this->fontface.'; font-size: '.$this->fontsize.'pt; font-weight: '.$this->fontweight.'; '.$this->getPosition($x,$y).' ">'.$this->string.'</div>'."\n";
    return $y;
  }
}

class xmlText extends xmlField {

  function xmlText($start){
    parent::xmlField($start);
  }
  
  function render($report,$x,$y) {
    echo '<div id="text" style="text-align: '.$this->halign.'; vertical-align: '.$this->valign.'; font-family: '.$this->fontface.'; font-size: '.$this->fontsize.'pt; font-weight: '.$this->fontweight.'; '.$this->getPosition($x,$y).' ">'.str_replace("\n",'<br>',$report->getSource($this->dataquery)->getField($this->datacolumn)).'</div>'."\n";
    return $y;
  }

}

class xmlImage extends xmlField {
var $mode;
var $map;
var $format;

  function xmlImage($start) {
    parent::xmlField($start);
    
    $this->properties['^MODE']='mode';
    $this->properties['^MAP']='map';
    $this->attributes['FORMAT']='format';
    $this->map = '';
  }
  
  function render($report,$x,$y) {
    /* save the image data and attach an image */
    if ($this->map != ''){
      $data=$this->map;
    } else if ($this->dataquery != '') {
      $data=$report->getSource($this->dataquery)->getField($this->datacolumn);
    }
    if ($data != ''){
      $filename='tmp/'.rand(10000000,99999999).'.jpg';
      // remove first and last row
      $data = substr($data,strpos($data,"\n")+1,strlen($data));
      $data = substr($data,0,strrpos(chop($data),"\n"));
//      file_put_contents($filename,$data);
      file_put_contents($filename,convert_uudecode($data));
      $size = '';
      $mode = '';
      if ($this->mode == 'stretch'){
        $s = getimagesize($filename);
        $w = IncToPix($this->width);
        $h = IncToPix($this->height);
        if (abs($s[0]-$w) <= abs($s[1]-$h)) {
          // keep the width
          $size = 'width: '.$w.'px; height:'.ceil($w*($s[1]/$s[0])).'px;';
        } else {
          // keep the height
          $size = 'width: '.ceil($s[0]*$h/$s[1]).'px; height:'.$h.'px;';
        }
      } else if ($this->mode == 'clip'){
         $mode='overflow: hidden;';
      }
      echo '<div id="image" style="'.$this->getPosition($x,$y).'; '.$mode.'"><img border="0" src="'.$filename.'" style="'.$size.'"></div>';
    }
  }
}

class xmlLine extends xmlDisplayElement {
  var $xstart,$ystart,$xend,$yend;
  var $weight;
  
  function xmlLine($start){
    parent::xmlDisplayElement($start);
    $this->properties['^XSTART']='xstart';
    $this->properties['^YSTART']='ystart';
    $this->properties['^XEND']='xend';
    $this->properties['^YEND']='yend';
    $this->properties['^WEIGHT']='weight';
  }

  function render($report,$x,$y){
    $this->height = $this->yend-$this->ystart;
    $this->width = $this->xend-$this->xstart;
    $this->x = $this->xstart;
    $this->y = $this->ystart;
    if ($this->weight == 0) { $this->weight = 1; }
    echo '<div id="line" style="border-top: '.$this->weight.'px solid #000; '.$this->getPosition($x,$y).' "></div>'."\n";
    return $y;
  }
}

class xmlPgHead extends xmlDisplayElement {
  var $name;
  var $height;
  var $fields;
  var $labels;
  var $texts;
  var $lines;
  var $firstpage;
  var $lastpage;
  
  
  function xmlPgHead($start = ''){
    if ($start!=''){
      $this->start = $start;
    } else {
      $this->start = 'PGHEAD';
    }
    $this->properties['^NAME']='name';
    $this->properties['^HEIGHT']='height';
    $this->properties['^FIRSTPAGE']='firstpage=true';
    $this->properties['^LASTPAGE']='lastpage=true';
    
    $this->objects['^FIELD']='fields';
    $this->objects['^IMAGE']='images';
    $this->objects['^LABEL']='labels';
    $this->objects['^TEXT']='texts';
    $this->objects['^LINE']='lines';
    
    $this->fields = new xmlElementList('xmlField','FIELD');
    $this->labels = new xmlElementList('xmlLabel','LABEL');
    $this->lines = new xmlElementList('xmlLine','LINE');
    $this->texts = new xmlElementList('xmlText','TEXT');
    $this->images = new xmlElementList('xmlImage','IMAGE');
  }
  
  function render($report,$x,$y){
    echo '<div id="pghead" style="border: 0px solid #000;'.$this->getPosition($x,$y).'">'."\n";
      foreach ($this->fields->elements as $o){
        $o->render($report,0,0);
      }
      foreach ($this->labels->elements as $o){
        $o->render($report,0,0);
      }
      foreach ($this->texts->elements as $o){
        $o->render($report,0,0);
      }
      foreach ($this->lines->elements as $o){
        $o->render($report,0,0);
      }
      foreach ($this->images->elements as $o){
        $o->render($report,0,0);
      }
    echo '</div>'."\n";
    return $y+IncToPix($this->height);
  }
}

class xmlPgFoot extends xmlDisplayElement {
  var $name;
  var $height;
  var $fields;
  var $labels;
  var $texts;
  
  function xmlPgFoot($start = ''){
    if ($start!=''){
      $this->start = $start;
    } else {
      $this->start = 'PGFOOT';
    }
    $this->properties['^NAME']='name';
    $this->properties['^HEIGHT']='height';
    
    $this->objects['^FIELD']='fields';
    $this->objects['^IMAGE']='images';
    $this->objects['^LABEL']='labels';
    $this->objects['^TEXT']='texts';
    $this->objects['^IMAGE']='images';
    
    $this->fields = new xmlElementList('xmlField','FIELD');
    $this->labels = new xmlElementList('xmlLabel','LABEL');
    $this->lines = new xmlElementList('xmlLine','LINE');
    $this->texts = new xmlElementList('xmlText','TEXT');
    $this->images = new xmlElementList('xmlImage','IMAGE');
  }
  
  function render($report,$x,$y){
    echo '<div id="pgfoot" style="border: 0px solid #ff0000;'.$this->getPosition($x,$y).'">'."\n";
      foreach ($this->fields->elements as $o){
        $o->render($report,0,0);
      }
      foreach ($this->labels->elements as $o){
        $o->render($report,0,0);
      }
      foreach ($this->texts->elements as $o){
        $o->render($report,0,0);
      }
      foreach ($this->lines->elements as $o){
        $o->render($report,0,0);
      }
      foreach ($this->images->elements as $o){
        $o->render($report,0,0);
      }
    echo '</div>'."\n";
    return $y+IncToPix($this->height);
  }
}

class xmlContextQuery extends xmlQuerySource {

  function xmlContextQuery(){
    $this->result[0]['page_number']=1;
    $this->result[0]['report_date']=date("Y/m/d");
  }

  function open($report){
    $this->pos = 0;
  }

  function isOpen(){
    return true;
  }
  
  function getField($name){
    return $this->result[0][$name];
  }

}

class xmlReport extends xmlElement {
  var $parameters;  
  var $sources;
  var $sections;
  var $pgheads;
  var $pgfoots;
  var $rpthead;
  
  var $title;
  var $name;
  var $description;
  var $pageSize;
  var $orientation;
  var $topmargin;
  var $bottommargin;
  var $rightmargin;
  var $leftmargin;
  
  function xmlReport(){
    $this->start = "REPORT";
    $this->objects['^PARAMETER']='parameters';
    $this->objects['^QUERYSOURCE']='sources';
    $this->objects['^SECTION']='sections';
    $this->objects['^PGHEAD']='pghead';
    $this->objects['^PGFOOT']='pgfoot';
    $this->objects['^RPTHEAD']='rpthead';
//    $this->objects['^RPTFOOT']='rptfoot';
    
    $this->properties['^TITLE']='title';
    $this->properties['^NAME']='name';
    $this->properties['^DESCRIPTION']='description';
    $this->properties['^SIZE']='pageSize';
    $this->properties['^PORTRAIT']='orientation=portrait';
    $this->properties['^LANDSCAPE']='orientation=landscape';
    $this->properties['^TOPMARGIN']='topmargin';
    $this->properties['^BOTTOMMARGIN']='bottommargin';
    $this->properties['^RIGHTMARGIN']='rightmargin';
    $this->properties['^LEFTMARGIN']='leftmargin';

    $this->parameters = new xmlElementList('xmlParameter','PARAMETER');
    $this->sources = new xmlElementList('xmlQuerySource','QUERYSOURCE');
    $this->sections = new xmlElementList('xmlSection','SECTION');
    $this->pghead = new xmlElementList('xmlPgHead','PGHEAD');
    $this->pgfoot = new xmlElementList('xmlPgFoot','PGFOOT');
    $this->rpthead = new xmlGroupHead('RPTHEAD');
  }
  
  function getSource($name){
    if ($name == 'Context Query'){
      return $this->contextquery;   
    } else if ($name == 'Parameter Query'){
      return new xmlContextQuery();   
    } else {
      foreach ($this->sources->elements as &$s){
        if ($s->name == $name){
          return $s;
        }
      }
    }
    return NULL;
  }

  function render(){
    $mt = IncToPix($this->topmargin);
    $ml = IncToPix($this->leftmargin);
    $mr = IncToPix($this->rightmargin);
    $mb = IncToPix($this->bottommargin);

    if ($this->orientation=='landscape'){
      $ysize = getPageWidth($this->pageSize);
      $xsize = getPageHeight($this->pageSize);
    } else {
      $xsize = getPageWidth($this->pageSize);
      $ysize = getPageHeight($this->pageSize);
    }
    $this->page = 1;
    $this->contextquery = new xmlContextQuery();
    $firstpage = true;
    foreach ($this->sources->elements as &$s ){
      $s->open($this);
    }
//    for ($i=1; $i<4; $i++){
      echo '<div id="pageshadow" style="position: absolute; background-color: #000000; height: '.($ysize).'px; width: '.($xsize).'px; top: '.(MARGIN_TOP+(($ysize+PAGE_SPACING)*($this->page-1))+5).'px; left: '.(MARGIN_LEFT+5).'px;">'."\n";
      echo '</div>'."\n";
      echo '<div id="page" style="position: absolute; background-color: #ffffff; height: '.($ysize).'px; width: '.($xsize).'px; top: '.(MARGIN_TOP+(($ysize+PAGE_SPACING)*($this->page-1))).'px; left: '.MARGIN_LEFT.'px;">'."\n";
      // render report header
      $y = $this->rpthead->render($this,$ml,$mt);
      $renderfirst = false;
      foreach ($this->pghead->elements as $o) {
        // render the page headers
        if ($o->firstpage=='true' and $firstpage){
          $y = $o->render($this,$ml,$y);
          $renderfirst = true;
        } else if (!$renderfirst){
          $y = $o->render($this,$ml,$y);
        }
      }
      /* render the sections */
      foreach ($this->sections->elements as $o){
        $y = $o->render($this,$ml,$y);
      }
      /* render the footer */
      $renderfirst = false;
      $y = $ysize - $mb;
      foreach ($this->pgfoot->elements as $o) {
        // render the page headers
        if ($o->firstpage=='true' and $firstpage){
          $o->render($this,$ml,$y-IncToPix($o->height));
          $renderfirst = true;
        } else if (!$renderfirst) {
          $o->render($this,$ml,$y-IncToPix($o->height));
        }
        $y -= IncToPix($o->height);
      }
      echo '</div>'."\n";
      $this->page++;
      $this->contextquery->result[0]['page_number']=$this->page;
      $firstpage = false;
//    }
  }  
}

class reportParser {
var $report;

  function reportParser() {
  }
  
  function loadReport($xml){
    $report = new xmlReport();
    /* need to do this, cause <? is not XML compliant */
    $xml = str_replace('&lt;?','??',str_replace('<?','??',str_replace('?>','??',$xml)));
    $xml_parser = xml_parser_create();
    xml_set_object($xml_parser,$report);
    xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, true);
    xml_set_element_handler($xml_parser,'elementStart','elementEnd');
    xml_set_character_data_handler($xml_parser, "elementData");
    xml_parse($xml_parser, $xml, true);
    xml_parser_free($xml_parser);
    return $report;
  }
}

?>